package com.muzhi.tianhe.controller;

import com.alibaba.fastjson.JSONObject;
import com.malk.server.common.McR;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Contacts;
import com.malk.utils.PublicUtil;
import com.malk.utils.UtilMap;
import com.muzhi.tianhe.mapper.TaskMapper;
import com.muzhi.tianhe.service.impl.TbApiService;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/task")
public class ThTaskController {

    @Autowired
    private TaskMapper taskMapper;
    @Autowired
    private DDClient_Contacts ddClient_contacts;
    @Autowired
    private DDClient ddClient;
    @Autowired
    private TbApiService tbApiService;

    @GetMapping("getUsers")
    public McR getUsers(String projectId){
        try {
            List<String> list=taskMapper.getUsers(projectId);
            List<Map> result=new ArrayList<>();
            for(String id:list){
                if(PublicUtil.isNull(id)){
                    continue;
                }

                result.add(UtilMap.map("id, name",id,getName(id)));
            }
            return McR.success(result);
        } catch (Exception e) {
            e.printStackTrace();
            return McR.error("201",e.getMessage());
        }
    }

    private String getName(String id){
//        return String.valueOf(ddClient_contacts.getUserInfoById(ddClient.getAccessToken(),id).get("name"));
        return tbApiService.getUsersInfo(Arrays.asList(tbApiService.getUserId(id,false))).getJSONObject(0).getString("name");
//        return id;
    }

    @GetMapping("selectColor")
    public McR selectColor(String projectId,String taskTypeId,String responsiblePerson){
        JSONObject param=new JSONObject();
        try {
            param.put("projectId",projectId);
            param.put("taskTypeId",taskTypeId);
            param.put("responsiblePerson",responsiblePerson);
            List<Map> list=taskMapper.selectColor(param);
            return McR.success(list);
        } catch (Exception e) {
            e.printStackTrace();
            return McR.error("201",e.getMessage());
        }
    }

    @GetMapping("selectColorByPerson")
    public McR selectColorByPerson(String projectId,String taskTypeId,String responsiblePerson){
        JSONObject param=new JSONObject();
        try {
            param.put("projectId",projectId);
            param.put("taskTypeId",taskTypeId);
            param.put("responsiblePerson",responsiblePerson);
            List<Map> list=taskMapper.selectColorByPerson(param);
            return McR.success(list);
        } catch (Exception e) {
            e.printStackTrace();
            return McR.error("201",e.getMessage());
        }
    }

}
