package com.muzhi.tianhe.entity;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Map;

@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "yikongTB信息", description = "易控TB信息")
public class Tianhe {

    @ExcelIgnore
    @ApiModelProperty(value = "项目编号")
    private String xiangmubianhao;

    @ExcelIgnore
    @ApiModelProperty(value = "任务编号")
    private String taskid;

    @ExcelProperty("项目名称")
    @ApiModelProperty(value = "项目名称")
    private String xiangmumingcheng;

    @ExcelProperty("项目类别")
    @ApiModelProperty(value = "项目类别")
    private String xiangmuleibie;

    @ExcelProperty("里程碑")
    @ApiModelProperty(value = "里程碑")//任务字段
    private String lichengbei;

    @ExcelProperty("所属周")
    @ApiModelProperty(value = "所属周")//任务字段
    private String suoshuzhou;

    @ExcelProperty("本周工作内容")
    @ApiModelProperty(value = "本周工作内容")//任务字段
    private String benzhougongzuoneirong;

    @ExcelProperty("下周工作计划")
    @ApiModelProperty(value = "下周工作计划")//任务字段
    private String xiazhougongzuojihua;

    @ExcelProperty("项目事项清单")
    @ApiModelProperty(value = "项目事项清单")//任务字段
    private String xiangmushixiangqingdan;

    @ExcelProperty("备注")
    @ApiModelProperty(value = "备注")//任务字段
    private String beizhu;

    @ExcelProperty("项目状态")
    @ApiModelProperty(value = "项目状态")
    private String xiangmuzhuangtai;

    @ExcelProperty("项目状态颜色")
    @ApiModelProperty(value = "项目状态颜色")
    private String xiangmuzhuangtaicolor;

    @ExcelProperty("项目负责人")
    @ApiModelProperty(value = "项目负责人")
    private String xiangmufuzeren;

    @ExcelIgnore
    @ApiModelProperty(value = "项目负责人编号")
    private String xiangmufuzerenid;

    @ExcelProperty("项目创建时间")
    @ApiModelProperty(value = "项目创建时间")
    private String xiangmuchuangjianshijian;

    @ExcelProperty("任务开始时间")
    @ApiModelProperty(value = "任务开始时间")//任务字段
    private String renwukaishishijian;

    @ExcelProperty("任务结束时间")
    @ApiModelProperty(value = "任务结束时间")//任务字段
    private String renwujieshushijian;

    @ExcelProperty("任务执行人")
    @ApiModelProperty(value = "任务执行人")//任务字段
    private String renwuzhixingren;

    @ExcelIgnore
    @ApiModelProperty(value = "任务执行人编号")//任务字段
    private String renwuzhixingrenid;


    // 此字段不映射到数据库表中
    @TableField(exist = false)
    @ExcelProperty("是否归档")
    private String shifouguidangStr;

    public String getShifouguidangStr() {
        return shifouguidang==0?"未归档":"已归档";
    }

    @ExcelIgnore
    @ApiModelProperty(value = "是否归档（0未归档；1已归档）")
    private int shifouguidang;

    @ExcelProperty("项目编号")
    @ApiModelProperty(value = "项目编号")
    private String glxiangmubianhao;

    @ExcelProperty("所属BU/MU/平台")
    @ApiModelProperty(value = "所属BU/MU/平台")
    private String glshuoshupingtai;

    @ExcelProperty("项目归属")
    @ApiModelProperty(value = "项目归属")
    private String glxiangmuguishu;

    @ExcelProperty("项目级别")
    @ApiModelProperty(value = "项目级别")
    private String glxiangmujibie;

    @ExcelProperty("涉及流程域")
    @ApiModelProperty(value = "涉及流程域")
    private String glsjlcy;

    @ExcelProperty("成本中心")
    @ApiModelProperty(value = "成本中心")
    private String glchengbenzhongxin;

    @ExcelProperty("项目预算（万元）")
    @ApiModelProperty(value = "项目预算（万元）")
    private String glxiangmuyusuan;

    @ExcelProperty("预算执行情况")
    @ApiModelProperty(value = "预算执行情况")
    private String glyusuanzhixingqingkuang;

    @ExcelProperty("是否属于关键任务分解")
    @ApiModelProperty(value = "是否属于关键任务分解")
    private String glsfsygjrwfj;

    @ExcelProperty("关键任务名称")
    @ApiModelProperty(value = "关键任务名称")
    private String glguanjianrenwumingcheng;

    @ExcelProperty("项目工期（天）")
    @ApiModelProperty(value = "项目工期（天）")
    private String glxiangmugongqi;

    @ExcelProperty("项目目标")
    @ApiModelProperty(value = "项目目标")
    private String glxiangmumubiao;

    @ExcelProperty("项目价值")
    @ApiModelProperty(value = "项目价值")
    private String glxiangmujiazhi;

    @ExcelProperty("项目范围")
    @ApiModelProperty(value = "项目范围")
    private String glxiangmufanwei;

    @ExcelProperty("项目实施策略")
    @ApiModelProperty(value = "项目实施策略")
    private String glxiangmushishicelue;

    @ExcelProperty("项目激励方案")
    @ApiModelProperty(value = "项目激励方案")
    private String glxiangmujili;

    @ExcelProperty("项目主要风险")
    @ApiModelProperty(value = "项目主要风险")
    private String glxiangmuzhuyaofengxian;

    public void setGl(Map<String,JSONArray> map){
        this.xiangmuleibie=getValue(map,"65bb984c7bbdd92f48e7264a");
        this.glxiangmubianhao=getValue(map,"65bb954d4d4dc9286d428a1e");
        this.glshuoshupingtai=getValue(map,"65d585a87bbdd92f48e9c83a");// 65bb97650bb530c9d7d02ada
        this.glxiangmuguishu=getValue(map,"65bb95dab6adf46ff2b468b7");
        this.glxiangmujibie=getValue(map,"65bb97d98f6d35714b539b26");
        this.glsjlcy=getValue(map,"65ed7ae2475c2137f57fcf25");
        this.glchengbenzhongxin=getValue(map,"65bb98935b255d16573fb64e");
        this.glxiangmuyusuan=getValue(map,"65bb98a2475c2137f56dd247");
        this.glyusuanzhixingqingkuang=getValue(map,"65bb98b34d4dc9286d428a75");
        this.glsfsygjrwfj=getValue(map,"65bb98d5b6adf46ff2b4692a");
        this.glguanjianrenwumingcheng=getValue(map,"65bb98e55b255d16573fb66f");
        this.glxiangmugongqi=getValue(map,"65bb992b2b8c25516cf7c033");
        this.glxiangmumubiao=getValue(map,"65bb993cb6adf46ff2b46952");
        this.glxiangmujiazhi=getValue(map,"65bb9946782229420a563452");
        this.glxiangmufanwei=getValue(map,"65bb99512b8c25516cf7c048");
        this.glxiangmushishicelue=getValue(map,"65bb9966b6adf46ff2b4696d");
        this.glxiangmujili=getValue(map,"65bb9974782229420a563469");
        this.glxiangmuzhuyaofengxian=getValue(map,"65bb998b2b8c25516cf7c05e");
    }

    private static String getValue(Map<String,JSONArray> map,String cfId){
        if(map.containsKey(cfId)){
            JSONArray array=map.get(cfId);
            if(array!=null&&array.size()>0){
                return array.getJSONObject(0).getString("title");
            }
        }
        return "";
    }
}
