package com.muzhi.tianhe.service.impl;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.malk.utils.UtilMap;
import com.muzhi.tianhe.service.AccessTokenService;
import com.muzhi.tianhe.util.PublicUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
@Slf4j
public class TbApiService {

    @Autowired
    private AccessTokenService accessTokenService;
    //私有化

    @Value("${teambition.domain}")
    public String PRIVATE_API_URL;
    @Value("${dingtalk.corpId}")
    public String DING_CORP_ID;
    @Value("${teambition.TenantId}")
    public String tbOrganizationId;
    @Value("${teambition.OperatorId}")
    public String tbOperatorId; // guhuchen

    public JSONArray getProjectList(){
        JSONObject result=new JSONObject();
        JSONArray array=new JSONArray();
        do {
            result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/query?pageSize=1000&pageToken="+result.getString("nextPageToken")));
            array.addAll(result.getJSONArray("result"));
        }while (!PublicUtil.isNull(result.getString("nextPageToken")));
        return array;
    }

    public JSONArray getProjectInfo(String projectId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/query?projectIds=" + projectId + "&pageSize=1000"));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksType(String projectId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/" + projectId + "/scenariofieldconfig/search"));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksType(String projectId,String sfcIds){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/" + projectId + "/scenariofieldconfig/search?sfcIds="+sfcIds));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksTypeByQ(String projectId,String q){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/" + projectId + "/scenariofieldconfig/search?q="+q));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksByType(String xmid,String rwlxid){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/" + xmid + "/task/query?q=sfcId = " + rwlxid + "&pageSize=1000"));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksByStageId(String xmid,String stageId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/" + xmid + "/task/query?q=stageId = " + stageId + "&pageSize=1000"));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksByQ(String xmid,String q){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/" + xmid + "/task/query?q=" + q + "&pageSize=1000"));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksInfo(String taskId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/task/query?taskId="+taskId));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksByParent(String parentTaskId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/task/query?parentTaskId="+parentTaskId));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectTfid(String projectId,String q){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/"+projectId+"/taskflow/search?q="+q));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectStateId(String projectId,String q,String tfIds,String tfsIds){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/"+projectId+"/taskflowstatus/search?q="+q+"&tfIds="+tfIds+"&tfsIds="+tfsIds));
        return result.getJSONArray("result");
    }

    public Object updateTaskStatus(String taskId,String taskflowstatusId){
        Map map=new HashMap();
        map.put("taskflowstatusId",taskflowstatusId);
        JSONObject result=header(HttpRequest.put(PRIVATE_API_URL + "/v3/task/{taskId}/taskflowstatus".replace("{taskId}",taskId))
                .header("x-operator-id",tbOperatorId)
                .body(JSONObject.toJSONString(map)));
        return result;
    }

    public JSONArray getProjectCust(String projectId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/"+ projectId +"/status/customfield/list"));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectCustomfield(String projectId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/"+ projectId +"/customfield/search?pageSize=1000"));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectCustomfield(String projectId,String sfcId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/"+ projectId +"/customfield/search?pageSize=1000&sfcId="+sfcId));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectRoleMember(String projectId,String id){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/"+ projectId +"/member").form("projectRoleId",id));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectTag(String projectId){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/{projectId}/project-tag".replace("{projectId}",projectId)));
        return result.getJSONArray("result");
    }

    public JSONArray getProjecGrouptTag(Map map){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project-tag/query").form(map));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectTaskflowsState(String projectId){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "v3/project/{projectId}/taskflowstatus/search".replace("{projectId}",projectId)));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectState(String projectId){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "v3/project/{projectId}/status/list".replace("{projectId}",projectId)));
        return result.getJSONArray("result");
    }

    public JSONArray getProjecTagUser(String projectTagId){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project-tag/{projectTagId}/project/query".replace("{projectTagId}",projectTagId)));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectRole(String projectId){
        Map param = new HashMap();
        param.put("pageSize", 1000);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/" + projectId + "/role")
                .form(param));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectMemberRole(String projectId,String userIds){
        Map param = new HashMap();
        param.put("userIds", userIds);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/"+projectId+"/member-role")
                .form(param));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectMember(String projectId){
        Map param = new HashMap();
        param.put("pageSize", 1000);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/"+projectId+"/member")
                .form(param));
        return result.getJSONArray("result");
    }

    public JSONArray userSearch(String userId){
        Map param = new HashMap();
        param.put("orgId",tbOrganizationId);
        param.put("query",userId);
        param.put("pageSize", 1000);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/org/member/search")
                .form(param));
        return result.getJSONArray("result");
    }

    public JSONArray idMapQuery(String userId, boolean isTbID){
        Map param = new HashMap();
        param.put("refer","dingTalk-user");
        param.put("refId",DING_CORP_ID);
        param.put(isTbID ? "tbId" : "extraUserId", userId);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/idmap/query")
                .form(param));
        return result.getJSONArray("result");
    }

    public JSONArray getTaskLinks(String taskId){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/task/"+ taskId +"/objectlinks")
                .header("x-operator-id",tbOperatorId));
        return result.getJSONArray("result");
    }

    public JSONObject addTaskLinks(String taskId,String title,String url,String linkedId){
        Map map=new HashMap();
        Map data=new HashMap();
        data.put("title",title);
        data.put("url",url);
        map.put("linkedData",data);
        map.put("linkedId",linkedId);
        map.put("linkedType","task");
        JSONObject result=header(HttpUtil.createPost(PRIVATE_API_URL + "/v3/task/"+ taskId +"/objectlinks")
                .body(JSONObject.toJSONString(map))
                .header("x-operator-id",tbOperatorId));
        return result.getJSONObject("result");
    }

    public Object updateTaskContent(String taskId,String content){
        Map map=new HashMap();
        map.put("content",content);
        JSONObject result=header(HttpRequest.put(PRIVATE_API_URL + "/v3/task/{taskId}/content".replace("{taskId}",taskId))
                .header("x-operator-id",tbOperatorId)
                .body(JSONObject.toJSONString(map)));
        return result;
    }

    public Object updateTaskExecutor(String taskId,String executor){
        Map map=new HashMap();
        map.put("executorId",executor);
        JSONObject result=header(HttpRequest.put(PRIVATE_API_URL + "/v3/task/{taskId}/executor".replace("{taskId}",taskId))
                .header("x-operator-id",tbOperatorId)
                .body(JSONObject.toJSONString(map)));
        return result;
    }

    public Object updateTaskCustomfield(String taskId,String customfieldId,String value){
        Map map=new HashMap();
        map.put("customfieldId",customfieldId);
        map.put("value", Arrays.asList(new JSONObject().fluentPut("title",value)));
        JSONObject result=header(HttpRequest.post(PRIVATE_API_URL + "/v3/task/{taskId}/customfield/update".replace("{taskId}",taskId))
                .header("x-operator-id",tbOperatorId)
                .body(JSONObject.toJSONString(map)));
        return result;
    }
    public Object updateTaskCustomfield(String taskId,String customfieldId,JSONArray value){
        Map map=new HashMap();
        map.put("customfieldId",customfieldId);
        map.put("value", value);
        JSONObject result=header(HttpRequest.post(PRIVATE_API_URL + "/v3/task/{taskId}/customfield/update".replace("{taskId}",taskId))
                .header("x-operator-id",tbOperatorId)
                .body(JSONObject.toJSONString(map)));
        return result;
    }

    public Object updateTaskLock(String taskId,Boolean isAdd,List<Map<String, String>> array){
        Map map=new HashMap();
        map.put(isAdd?"add":"del", array);
        JSONObject result=header(HttpRequest.post(PRIVATE_API_URL + "/v3/task/{taskId}/access-policy/update".replace("{taskId}",taskId))
                .header("x-operator-id",tbOperatorId)
                .body(JSONObject.toJSONString(map)));
        return result;
    }

    public JSONObject addTask(JSONObject param){
        JSONObject result=header(HttpRequest.post(PRIVATE_API_URL + "/v3/task/create")
                .header("x-operator-id",tbOperatorId)
                .body(JSONObject.toJSONString(param)));
        return result;
    }

    public String getUserId(String id,Boolean isTB){
        if(StringUtils.isBlank(id)){
            return "";
        }
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/idmap/dingtalk/"+(isTB?"getDingUserId?tbUserIds=":"getTbUserId?dingUserIds=")+id));
        return result.getJSONArray("result").getJSONObject(0).getString(isTB?"dingtalkUserId":"tbUserId");
    }

    public List<String> getUserIds(String ids,Boolean isTB){
        if(StringUtils.isBlank(ids)){
            return Arrays.asList();
        }
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/idmap/dingtalk/"+(isTB?"getDingUserId?tbUserIds=":"getTbUserId?dingUserIds=")+ids));
        return result.getJSONArray("result").toJavaList(Map.class).stream().map(item->{
            return UtilMap.getString(item,isTB?"dingtalkUserId":"tbUserId");
        }).collect(Collectors.toList());
    }

    public JSONArray getUsersInfo(List<String> ids){// userIds
        JSONObject result=header(HttpUtil.createPost(PRIVATE_API_URL + "/org/member/batchGet").body(JSONObject.toJSONString(UtilMap.map("userIds",ids))));
        return result.getJSONArray("result");
    }

    public Map getUsersMapList(List<String> ids,Boolean isTB){
        JSONArray array=getUsersInfo(isTB?ids:getUserIds(String.join(",",ids),false));
        Map map=new HashMap();
        for (int i = 0; i < array.size(); i++) {
            map.put(ids.get(i),array.getJSONObject(i));
        }
        return map;
    }

    public JSONArray getStageId(String projectId,String q){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/{projectId}/stage/search?q=".replace("{projectId}",projectId)+q));
        return result.getJSONArray("result");
    }


    public JSONObject addProjectState(String projectId,Map param){
        JSONObject result=header(HttpRequest.post(PRIVATE_API_URL + "/v3/project/{projectId}/status/create".replace("{projectId}",projectId))
                .header("x-operator-id",tbOperatorId)
                .body(JSONObject.toJSONString(param)));
        return result;
    }


    private JSONObject header(HttpRequest request){
        try {
            request.header("Authorization","Bearer " + accessTokenService.getAppToken())
                    .header("X-Tenant-Id", tbOrganizationId)
                    .header("X-Tenant-Type", "organization");
            String resultStr=request.execute().body();
            JSONObject result=JSONObject.parseObject(resultStr);
            if(!result.getString("code").equals("200")){
                log.error("请求失败！返回数据：{}",resultStr);
                return new JSONObject();
            }
            return result;
        }catch (Exception e){
            e.printStackTrace();
            log.error("请求异常！错误信息：{}",e);
            return new JSONObject();
        }
    }

}
